﻿namespace UltraChartExportToExcell
{
    using System;
    using System.Diagnostics;
    using System.Drawing;
    using System.Drawing.Imaging;
    using System.IO;
    using System.Windows.Forms;

    using Infragistics.Documents.Excel;

    public partial class Form1 : Form
    {
        private string imageFileName = "test.jpeg";
        private string workbookFileName = "test.xlsx";
        private int imageWidth = 600;
        private int imageHeight = 400;
        private int imageDPI = 96;

        public Form1()
        {
            this.InitializeComponent();
        }

        private void ButtonExport_Click(object sender, EventArgs e)
        {
            Workbook wb = new Workbook();
            wb.SetCurrentFormat(WorkbookFormat.Excel2007);
            Worksheet ws = wb.Worksheets.Add("Chart");

            using (FileStream fs = File.Create(this.imageFileName))
            {
                this.ultraChart1.SaveTo(
                    fs,
                    ImageFormat.Jpeg,
                    new Size(this.imageWidth, this.imageHeight),
                    new SizeF(this.imageDPI, this.imageDPI));
            }

            Image image = Image.FromFile(this.imageFileName);
            WorksheetImage cellIamge = new WorksheetImage(image);
            WorksheetCell cellA1 = ws.Rows[0].Cells[0];

            ws.Columns[0].Width = (int)((this.imageWidth - 12) / 7d + 1) * 256;
            ws.Rows[0].Height = this.imageHeight * 1440 / this.imageDPI;

            cellIamge.TopLeftCornerCell = cellA1;
            cellIamge.TopLeftCornerPosition = new PointF(0f, 0f);
            cellIamge.BottomRightCornerCell = cellA1;
            cellIamge.BottomRightCornerPosition = new PointF(100f, 100f);

            ws.Shapes.Add(cellIamge);

            wb.Save(this.workbookFileName);

            Process.Start(this.workbookFileName);
        }
    }
}
